Index: code/branches/doc/doc/api/Groups.dox
===================================================================
--- code/branches/doc/doc/api/Groups.dox	(revision 7334)
+++ code/branches/doc/doc/api/Groups.dox	(revision 7335)
@@ -56,4 +56,10 @@
     @defgroup Command Command
     @ingroup Core
+*/
+
+/**
+    @defgroup CmdArgs Commandline Arguments
+    @ingroup Command
+    @brief For a reference see @ref cmdargs
 */
 
Index: code/branches/doc/doc/api/doxy.config.in
===================================================================
--- code/branches/doc/doc/api/doxy.config.in	(revision 7334)
+++ code/branches/doc/doc/api/doxy.config.in	(revision 7335)
@@ -191,5 +191,5 @@
 # You can put \n's in the value part of an alias to insert newlines.
 
-ALIASES                =
+ALIASES                = "cmdarg=\xrefitem cmdargs \"Commandline Argment\" \"Commandline Arguments Reference\""
 
 # Set the OPTIMIZE_OUTPUT_FOR_C tag to YES if your project consists of C
Index: code/branches/doc/src/libraries/core/CommandLineParser.cc
===================================================================
--- code/branches/doc/src/libraries/core/CommandLineParser.cc	(revision 7334)
+++ code/branches/doc/src/libraries/core/CommandLineParser.cc	(revision 7335)
@@ -41,4 +41,5 @@
 namespace orxonox
 {
+    //! @cmdarg
     SetCommandLineOnlyArgument(optionsFile, "start.ini").shortcut("o");
 
Index: code/branches/doc/src/libraries/core/Core.cc
===================================================================
--- code/branches/doc/src/libraries/core/Core.cc	(revision 7334)
+++ code/branches/doc/src/libraries/core/Core.cc	(revision 7335)
@@ -77,8 +77,11 @@
     Core* Core::singletonPtr_s  = 0;
 
+    //! @cmdarg
     SetCommandLineArgument(settingsFile, "orxonox.ini").information("THE configuration file");
+    //! @cmdarg
     SetCommandLineSwitch(noIOConsole).information("Use this if you don't want to use the IOConsole (for instance for Lua debugging)");
 
 #ifdef ORXONOX_PLATFORM_WINDOWS
+    //! @cmdarg
     SetCommandLineArgument(limitToCPU, 1).information("Limits the program to one CPU/core (1, 2, 3, etc.). Default is the first core (faster than off)");
 #endif
Index: code/branches/doc/src/libraries/core/PathConfig.cc
===================================================================
--- code/branches/doc/src/libraries/core/PathConfig.cc	(revision 7334)
+++ code/branches/doc/src/libraries/core/PathConfig.cc	(revision 7335)
@@ -70,5 +70,7 @@
     PathConfig* PathConfig::singletonPtr_s  = 0;
 
+    //! @cmdarg
     SetCommandLineArgument(externalDataPath, "").information("Path to the external data files");
+    //! @cmdarg
     SetCommandLineOnlyArgument(writingPathSuffix, "").information("Additional subfolder for config and log files");
 
Index: code/branches/doc/src/libraries/core/input/InputManager.cc
===================================================================
--- code/branches/doc/src/libraries/core/input/InputManager.cc	(revision 7334)
+++ code/branches/doc/src/libraries/core/input/InputManager.cc	(revision 7335)
@@ -60,4 +60,5 @@
 namespace orxonox
 {
+    //! @cmdarg
     SetCommandLineSwitch(keyboard_no_grab).information("Whether not to exclusively grab the keyboard");
 
Index: code/branches/doc/src/orxonox/LevelManager.cc
===================================================================
--- code/branches/doc/src/orxonox/LevelManager.cc	(revision 7334)
+++ code/branches/doc/src/orxonox/LevelManager.cc	(revision 7335)
@@ -42,4 +42,5 @@
 namespace orxonox
 {
+    //! @cmdarg
     SetCommandLineArgument(level, "").shortcut("l").information("Default level file (overrides LevelManager::defaultLevelName_ configValue)");
 
Index: code/branches/doc/src/orxonox/Main.cc
===================================================================
--- code/branches/doc/src/orxonox/Main.cc	(revision 7334)
+++ code/branches/doc/src/orxonox/Main.cc	(revision 7335)
@@ -43,12 +43,4 @@
 #include "Main.h"
 
-SetCommandLineSwitch(console).information("Start in console mode (text IO only)");
-// Shortcuts for easy direct loading
-SetCommandLineSwitch(server).information("Start in server mode");
-SetCommandLineSwitch(client).information("Start in client mode");
-SetCommandLineSwitch(dedicated).information("Start in dedicated server mode");
-SetCommandLineSwitch(standalone).information("Start in standalone mode");
-SetCommandLineSwitch(dedicatedClient).information("Start in dedicated client mode");
-
 DeclareToluaInterface(Orxonox);
 DeclareToluaInterface(Network);
@@ -56,4 +48,17 @@
 namespace orxonox
 {
+    //! @cmdarg
+    SetCommandLineSwitch(console).information("Start in console mode (text IO only)");
+    //! @cmdarg
+    SetCommandLineSwitch(server).information("Start in server mode");
+    //! @cmdarg
+    SetCommandLineSwitch(client).information("Start in client mode");
+    //! @cmdarg
+    SetCommandLineSwitch(dedicated).information("Start in dedicated server mode");
+    //! @cmdarg
+    SetCommandLineSwitch(standalone).information("Start in standalone mode");
+    //! @cmdarg
+    SetCommandLineSwitch(dedicatedClient).information("Start in dedicated client mode");
+
     /**
     @brief
Index: code/branches/doc/src/orxonox/gamestates/GSClient.cc
===================================================================
--- code/branches/doc/src/orxonox/gamestates/GSClient.cc	(revision 7334)
+++ code/branches/doc/src/orxonox/gamestates/GSClient.cc	(revision 7335)
@@ -40,4 +40,5 @@
     DeclareGameState(GSClient, "client", false, false);
 
+    //! @cmdarg
     SetCommandLineArgument(dest, "127.0.0.1").information("Server hostname/IP (IP in the form of #.#.#.#)");
 
Index: code/branches/doc/src/orxonox/gamestates/GSServer.cc
===================================================================
--- code/branches/doc/src/orxonox/gamestates/GSServer.cc	(revision 7334)
+++ code/branches/doc/src/orxonox/gamestates/GSServer.cc	(revision 7335)
@@ -39,4 +39,5 @@
     DeclareGameState(GSServer, "server", false, false);
 
+    //! @cmdarg
     SetCommandLineArgument(port, 55556).shortcut("p").information("Network communication port to be used 0-65535 (default: 55556)");
 